module ActiveDirectory
  module Configuration
    extend self

    def reset!
      attributes.clear
    end

    def attributes
      @attributes ||= {}
    end

    def ldap_treebase(ldap_treebase=nil)
      if ldap_treebase
        self.ldap_treebase = ldap_treebase
      else
        attributes[:ldap_treebase] ||
        raise(ConfigurationError,
          '#ldap_treebase is a required configuration value.')
      end
    end

    def ldap_treebase=(ldap_treebase)
      attributes[:ldap_treebase] = ldap_treebase
    end

    def ldap_host(ldap_host=nil)
      if ldap_host
        self.ldap_host = ldap_host
      else
        attributes[:ldap_host] ||
        raise(ConfigurationError,
          '#ldap_host is a required configuration value.')
      end
    end

    def ldap_host=(ldap_host)
      attributes[:ldap_host] = ldap_host
    end

    def ldap_port(ldap_port=nil)
      if ldap_port
        self.ldap_port = ldap_port
      else
        attributes[:ldap_port] ||
        raise(ConfigurationError,
          '#ldap_port is a required configuration value.')
      end
    end

    def ldap_port=(ldap_port)
      attributes[:ldap_port] = ldap_port
    end

    def username(username=nil)
      if username
        self.username = username
      else
        attributes[:username] ||
        raise(ConfigurationError,
          '#username is a required configuration value.')
      end
    end

    def username=(username)
      attributes[:username] = username
    end

    def password(password=nil)
      if password
        self.password = password
      else
        attributes[:password] ||
        raise(ConfigurationError,
          '#password is a required configuration value.')
      end
    end

    def password=(password)
      attributes[:password] = password
    end

    def log(path = nil)
      self.log = path if path
      attributes[:log]
    end

    def log=(path)
      attributes[:log] = path
    end

    def logger
      attributes[:logger] ||= ::Logger.new (log && !log.empty?) ? log : $stdout
    end
  end
end
