module ActiveDirectory
  class DirectoryObject

    def initialize(options={})
      self.class.fields.each do |k, v|
        self.class.__send__(:attr_accessor, v)
        if options[k.to_sym].kind_of?(Array)
          self.__send__("#{v}=", options[k.to_sym].first)
        else
          self.__send__("#{v}=", options[k.to_sym])
        end
      end
    end

    def update
      self.class.fields.each do |k, v|
        # puts k, instance_variable_get("@#{v}")
        Client.update_attribute(@dn, k, instance_variable_get("@#{v}"))
      end
    end

    def rename(new_dn)
      Client.rename(@dn, new_dn)
      #puts "test"
    end

    def create
      puts build_create_data
      Client.add(@dn, build_create_data)
    end

    def delete
      Client.delete(@dn)
    end

    def self.fields(fields = {})
      fields
    end
  end
end
